VERSION 5.00
Begin VB.Form HashBufferTest 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Buffer Hash"
   ClientHeight    =   2748
   ClientLeft      =   1548
   ClientTop       =   3600
   ClientWidth     =   5904
   Icon            =   "HashBufferTest.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   Moveable        =   0   'False
   ScaleHeight     =   2748
   ScaleWidth      =   5904
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton bt_Close 
      Caption         =   "Close"
      Height          =   375
      Left            =   4200
      TabIndex        =   7
      Top             =   1200
      Width           =   1335
   End
   Begin VB.Frame fr_Algo 
      Caption         =   "Algorithm"
      Height          =   615
      Left            =   120
      TabIndex        =   4
      Top             =   1080
      Width           =   1935
      Begin VB.OptionButton op_Algo 
         Caption         =   "MD5"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   6
         Top             =   240
         Value           =   -1  'True
         Width           =   855
      End
      Begin VB.OptionButton op_Algo 
         Caption         =   "SHA-1"
         Height          =   255
         Index           =   1
         Left            =   960
         TabIndex        =   5
         Top             =   240
         Width           =   855
      End
   End
   Begin VB.Frame fr_Buffer 
      Caption         =   "Input Buffer"
      Height          =   855
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   5655
      Begin VB.TextBox txt_Buffer 
         Height          =   285
         Left            =   120
         TabIndex        =   3
         Text            =   "abc"
         Top             =   360
         Width           =   5295
      End
   End
   Begin VB.CommandButton bt_Hash 
      Caption         =   "HASH !!!"
      Height          =   375
      Left            =   2400
      TabIndex        =   1
      Top             =   1200
      Width           =   1335
   End
   Begin VB.Frame fr_Result 
      Caption         =   "Hex Value"
      Height          =   855
      Left            =   120
      TabIndex        =   0
      Top             =   1800
      Width           =   5655
      Begin VB.TextBox txt_Result 
         BackColor       =   &H80000013&
         Height          =   285
         Left            =   120
         TabIndex        =   8
         Top             =   360
         Width           =   5415
      End
   End
End
Attribute VB_Name = "HashBufferTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub bt_Close_Click()

    Unload Me

End Sub

'
'   This method tests the digest API (HashData)
'
'   15/12/01 14:40 NDP - test the hex conv methods
'   24/05/04 11:10 NDP - new DLL with VARIANTS

Private Sub bt_Hash_Click()

    Dim CryptoTools As New SaCryptoAPI
    Dim CryptoConv As New SaCryConv
    
    Dim Try
    Dim bOutput   As Variant
    Dim sOutput0 As String
    Dim sAlgorithm As String
    
    Me.MousePointer = 11
         
    ' Get Algorithm choice
    For Each Try In op_Algo
        
        If Try.Value = True Then
            
            sAlgorithm = Try.Caption
            Exit For
            
        End If
        
    Next
        
    'Initialize Digest
    CryptoTools.hashDataBufferInit (sAlgorithm)
    
    If CryptoTools.isOperationOK() Then
        txt_Result.Text = "Operation effectue avec succs."
    Else
        txt_Result.Text = "Failure 1"
        MsgBox CryptoTools.getRawError()
        Exit Sub
    End If
    
    ' Convert text to hash and put it into Digest Buffer
    Dim bBufferToHash As Variant
    bBufferToHash = CryptoConv.convertStringToBytes(txt_Buffer.Text)
    CryptoTools.hashDataBuffer (bBufferToHash)
    
    If CryptoTools.isOperationOK() Then
        txt_Result.Text = "Operation effectue avec succs."
    Else
        MsgBox CryptoTools.getRawError()
        Exit Sub
    End If
    
    ' Get the result of the digest for the buffer
    Dim HashValue As Variant
    HashValue = CryptoTools.hashDataBufferDigest()

    If CryptoTools.isOperationOK() Then
        txt_Result.Text = "Operation effectue avec succs."
    Else
        MsgBox CryptoTools.getRawError()
        Exit Sub
    End If
    
    Me.MousePointer = 0
    
    ' print result
    sOutput = CryptoConv.convertBytesToHexString(HashValue)
    
    txt_Result.Text = sAlgorithm & " - " & Len(sOutput) * 4 & "bits : " & sOutput

End Sub

