// TestLoop.cpp: implementation of the CTestLoop class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SafeApiExample.h"

#include "TestSafeApi.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTestLoop::CTestLoop()
{

}

CTestLoop::~CTestLoop()
{

}

//////////////////////////////////////////////////////////////////////
// Load SafeAPI in memory
//////////////////////////////////////////////////////////////////////

void CTestLoop::loadSafeApi(IConvert convert, ICryptoSym safeapi)
{
    m_convert = convert;
	m_safeapi = safeapi;
}

//////////////////////////////////////////////////////////////////////
// Test SafeAPI main APIs
//////////////////////////////////////////////////////////////////////

void CTestLoop::test()
{
    
	CString sAlgorithm  = "Blowfish";
    CString sPassphrase = "notre passphrase";
    CString sEmail      = "test@safeapi.com";
    CString sError;

    //
    // We use VARIANT in COlevariant MFC Classes to pass or store binary arrays 
    //
	COleVariant coleSeed = "tranform that string to binary seed";

    // Key Generation
    m_safeapi.genSecretKey(sAlgorithm, sPassphrase, 128,
                        coleSeed, sEmail, 1);

    CString sKeyId = sEmail + "_1_" + sAlgorithm;     
    
    //AfxMessageBox("GenSecretKey done. key is stored using Key Id: " + sKeyId);

    // Error cheking
    if (! m_safeapi.isOperationOK())
    {
        sError = m_safeapi.getRawError();
        AfxMessageBox(sError);
    }

    //
    // Buffer encryption/decryption tests
    // 

    // We set the string to encrypt to the COleVariant
    // Note:  we can pass also a byte array (unsigned char *)  as a CByteArray
    //        coleDec = byteArray

    CString sString = "Ceci est une phrase a chiffrer et a dechiffrer.";
    COleVariant coleDec = sString;
	
    COleVariant coleEnc = m_safeapi.encryptBuffer(sKeyId, sPassphrase, coleDec);
    
    int nEnd = 2;
    int nCpt =0;
    
    while (true)
    {	
       nCpt++;
    // Encrypt the String

        VARIANT vEnc;
        VARIANT vDec;

        vEnc = m_safeapi.encryptBuffer(sKeyId, sPassphrase, coleDec);
        vDec = m_safeapi.decryptBuffer(sKeyId, sPassphrase, vEnc);
       
        CString sStringDec = m_convert.bytesToString(vDec);

	    if ( sString != sStringDec )
	    {
		    AfxMessageBox("Decryption failed!");
            AfxMessageBox( "sStringDec :" + sStringDec + ":");
            AfxMessageBox( "sString    :" + sString   + ":");
		    return;
	    }
	    else
        {   

            CString sResult = "Decryption successfull! : " + sStringDec;
            //AfxMessageBox(sResult);
        }
            

        //VariantClear(&vEnc);
        //VariantClear(&vDec);

        if (nEnd == nCpt)
        {
            break;
        }
    }

    return;

}
