// 16/09/00 17:50 NDP - new package name

package com.safeapi.test;


import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;

public class BigFileMaker
{
	BufferedOutputStream m_bosOut ;
	byte m_bBuf4k[] ;

	public BigFileMaker()
	{
		buildBuf4k() ;		
	}
	
	public static void Main(String args[])
	{
		BigFileMaker cbfmMake = new BigFileMaker() ;
		
		cbfmMake.writeMegs(args[0], Integer.parseInt(args[1])) ;
	}

	protected void openOutput(String sOutputPath)
	{
		try{
			m_bosOut = new BufferedOutputStream(
								new FileOutputStream(sOutputPath)) ;
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace() ;
		}
	}
	
	protected void closeOutput()
	{
		try{			
			if(m_bosOut != null)
				m_bosOut.close() ;
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace() ;
		}
	}
	
	protected void buildBuf4k()
	{
		m_bBuf4k = new byte[4096] ;
		Integer IConv ;
		
		for(int nCnt = 0 ; nCnt < m_bBuf4k.length ; nCnt++)
		{
			IConv = new Integer(nCnt % 10) ;
			m_bBuf4k[nCnt] = IConv.byteValue() ;
		}		
	}
	
	protected void writeOneMeg()
	{
		try{
			int nLoopCount = 1024 / 4 ; // (we have a 4k buffer)
			
			for(int nCnt = 0 ; nCnt < nLoopCount ; nCnt++)
			{
				m_bosOut.write(m_bBuf4k) ;
			}
			
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace() ;
		}
	}

	public void writeMegs(String sOutputPath, int nSizeInMeg)
	{
		System.out.println("Open stream") ;
		
		openOutput(sOutputPath) ;
		
		System.out.println("Writing megs : ") ;
		
		for(int nCnt = 0 ; nCnt < nSizeInMeg ; nCnt++)
		{
			writeOneMeg() ;
			System.out.print(".") ;
		}
		
		System.out.println() ;
		
		System.out.println("Close stream") ;
		
		closeOutput() ;
		
		System.out.println("End") ;
	}
}
