// CryptFile : SafeAPI Package.
// Class Description   : Test & becnhmark symmetric file encryption/decryption.
//						 
// 15/07/00 20:00 NDP - Creation

package com.safeapi.test;

import com.safeapi.CryptoSym;
import com.safelogic.crytools.ParmCry;

public class CryptFile
{
	
	public static String KEY_EMAIL = "test_safeapi@safelogic.com";
	public static String KEY_PASS  = "test_safeapi@safelogic.com";
	
    //
    // Socket buffer size
    //

    public final static int CSA_SOCKET_BUFFER = 2048;    
    
	private static void DisplayUsage()
	{
		System.out.println("java com.safeapi.CryptFile <in> [out]");
		System.out.println("where:");		
		System.out.println("- option switches: <-s|+s> <-k|+k>");
		System.out.println("  +s|-s : seed generation | no seed generation");
		System.out.println("  +k|-k : key generation  | no key generation");
		System.out.println("- in             : input file");
		System.out.println("- out            : output file. (Defaults to in + .out");
				
	}	
		
	/**
	 * TestCryptDir buffer & file encrytpion 
	 * @param sFile			File to use for tests
	 * @param sOptionKey	Batch option
	 * @param sAlgo			symmetric algorithm
	 * @param bRaw			if true ==> use Raw symmetric buffer encryption
	 */
	
	private static void crypt(	String sFileIn, 
								String sFileOut,
								String sOptionKey, 
								String sAlgo)
		throws Exception
	{		
		// Generate symmetric keys
		TestSym csa_test_sym = new TestSym(sAlgo, KEY_EMAIL, KEY_PASS);
		
		if (sOptionKey.indexOf("+k") != -1)
		{		
			csa_test_sym.testGenKey();	
		}
	
		String sFileInDec = sFileIn + ".dec";
		
		//new File(sFileOut).delete();
		//new File(sFileInDec).delete();
		
		csa_test_sym.testSymEncrypt(sFileIn, sFileOut);
		
		csa_test_sym.testSymDecrypt(sFileOut, sFileInDec);
		csa_test_sym.testCompFile(sFileIn, sFileInDec);				
	}
	
	/**
	 * M A I N
	 */
	public static void main(String[] args)
		throws Exception 
	{        
		if (args.length != 3 && args.length != 4 )
		{
			DisplayUsage();
			return;
		}
		String sOptionSeed;
		String sOptionKey;
		String sFileIn;		
		String sFileOut;
		
		 sOptionSeed = new String(args[0]);
		 sOptionKey  = new String(args[1]);
		 sFileIn	 = new String(args[2]);
		 
		if ( args.length == 4 )
		{
			sFileOut	= new String(args[3]); 
		}
		else
		{
			sFileOut	= sFileIn + ".enc"; 
		}
		
		// Build a seed file
		
		CryptoSym safeapi	= new CryptoSym();
		
		if (sOptionSeed.indexOf("+s") != -1)
		{
			safeapi.createSeedFile("gnration de seed",
							   "Veuillez taper lentement sur le clavier");
		}
		
		String sAlgo = ParmCry.CSA_ALGO_BLOWFISH;
		crypt(sFileIn, sFileOut, sOptionKey, sAlgo);
				
	}
			
}	