// TestConv.java  : SafeAPI Package.
// Class Description  : This class contains utils for the Convert  class.
//
// 15/12/01 14:05 NDP - Creation

package com.safeapi.test;

// REFERENCE CLASS USED TO TEST SXAFEAPI INSTALL - DO NO MODIFY

import com.safeapi.Convert;

/**
 * This Class is designed to TestCryptDir the hash methods of SafeAPI.
 * 
 */

public class TestConv 
{
	// attributes
	
	Convert m_ccvConverter = new Convert() ;
	
	/**
	 * main method
	 * 
	 * @param	args	The Strings to hash contained in command line
	 * 
	 */
	
	public static void main(String[] args)
	{	
		TestConv cctConv	= new TestConv() ;
		
		for(int nCnt=0 ; nCnt < args.length ; nCnt++)
		{
			cctConv.testConv(args[nCnt]) ;
		}		
	}

	// constructor
	
	/**
	 * simple constructor
	 */
	
	public TestConv()
	{
		m_ccvConverter = new Convert() ;	
	}
	
	// methods
	
	/**
	 * TestCryptDir the Convert functionnality of SafeAPI with the provided String buffer.
	 * <BR>
	 * This tests both MD5 and SHA-1 algorithms.
	 * 
	 * @param	the buffer to use to TestCryptDir Conv algorithms
	 */
	
	public void testConv(String sIn)
	{
		System.out.println();
				
		byte b[] = m_ccvConverter.stringToBytes(sIn);
		
		String sInHex = m_ccvConverter.bytesToHexString(b);
		System.out.println("sInToHex   : " + sInHex );
		
		byte b2[] = m_ccvConverter.hexStringToBytes(sInHex);
		
		String sIn2 = m_ccvConverter.bytesToString(b2);
		System.out.println("ByteTo_sIn : " + sIn2 );
	}

}

// End