// TestCryptDir.java: SafeAPI Package.
// Class Description  : Auto TestCryptDir of  SafeAPI symmetric dir crypto
//					 
// 12/02/03 17:05 NDP- 1st Release

package com.safeapi.test;

import com.safeapi.CryptoDir;
import com.safeapi.util.ParmsInternal;
import com.safelogic.crytools.SafeProvider;

/**
 * @author Administrateur
 */
public class TestCryptDir
{
    // set to true to force debug
    public static boolean CSA_DEBUG = false;
    
    public static final int ENCRYPT_MODE = 1;
    public static final int DECRYPT_MODE = 2;    
    
    public static void main(String[] args)throws Exception
    {
        
        if (args.length == 0 || args.length != 3)
        {
            System.out.println("TestCryptDir inputDir OutputDir <1 (encrypt) | 2 (decrypt)> ");
            return;
        }
        
        // Add Cryptix provider dynamically
        SafeProvider.add();        
                
        String sInputDir = null;
        String sOutputDir = null;
        int nMode = 0;
        
        sInputDir  = args[0];        
        sOutputDir = args[1];
        nMode = new Integer(args[2]).intValue();
                        
        String sAlgorithm  = "Blowfish";
        String sPassphrase = "I want to TestCryptDir now!";
        	                      
        CryptoDir safeapi = new CryptoDir() ;
        
        if (nMode == ParmsInternal.ENCRYPT_MODE )
        {
            safeapi.encryptDirWithPassphrase(
        		sAlgorithm, 
        		sPassphrase.toCharArray(), 
        		sInputDir, 
        		sOutputDir);
        }
        else if (nMode == ParmsInternal.DECRYPT_MODE )
        {
            safeapi.decryptDirWithPassphrase(
                sAlgorithm, 
                sPassphrase.toCharArray(), 
                sInputDir, 
                sOutputDir);
        }
    }
}
