// TestHash.java  : SafeAPI Package.
// Class Description  : This class contains utils for the CryptoCommon class.
// 20/11/99 00:30 GR - Release
// 20/11/99 01:15 GR - Add comments
// 14/07/00 18:25 NDP- New 1.02 version - This is a reference class
// 16/09/00 17:50 NDP - new package name

package com.safeapi.test;

// REFERENCE CLASS USED TO TEST SXAFEAPI INSTALL - DO NO MODIFY

import com.safeapi.Convert;
import com.safeapi.CryptoHash;

/**
 * This Class is designed to TestCryptDir the hash methods of SafeAPI.
 * 
 */

public class TestHash 
{
	// attributes
	
	CryptoHash m_ccaSafeTest ;
	
	/**
	 * main method
	 * 
	 * @param	args	The Strings to hash contained in command line
	 * 
	 */
	
	public static void main(String[] args)
	{	
		TestHash cctHash	= new TestHash() ;
		
		//System.out.println() ;
		//System.out.println(cctHash.m_safeapi.getVersion(true)) ;
		
		for(int nCnt=0 ; nCnt < args.length ; nCnt++)
		{
			cctHash.testHash(args[nCnt]) ;
		}
	}

	// constructor
	
	/**
	 * simple constructor
	 */
	
	public TestHash()
	{
		m_ccaSafeTest = new CryptoHash() ;		
	}
	
	// methods
	
	/**
	 * TestCryptDir the hash functionnality of SafeAPI with the provided String.
	 * <BR>
	 * This tests both MD5 and SHA-1 algorithms.
	 * 
	 * @param	the String to use to TestCryptDir hash algorithms
	 */
	
	protected void testHash(String sToHash)
	{
		//System.out.println(sToHash);
		testHash(sToHash.getBytes()) ;
	}
	
	
	/**
	 * TestCryptDir the hash functionnality of SafeAPI with the provided buffer.
	 * <BR>
	 * This tests both MD5 and SHA-1 algorithms.
	 * 
	 * @param	the buffer to use to TestCryptDir hash algorithms
	 */
	
	protected void testHash(byte[] bToHash)
	{
		byte[] bDigest ;
		String sAlgo = new String() ;
		Convert ccvConverter = new Convert() ;
		
		System.out.println();
		
		for(int nCnt = 0 ; nCnt < 2 ; nCnt ++)
		{
			if(nCnt == 0)
			{
				sAlgo = "MD5" ;
			}
			else
			{
				sAlgo = "SHA-1" ;
			}
			
			m_ccaSafeTest.hashDataBufferInit(sAlgo) ;
			m_ccaSafeTest.hashDataBuffer(bToHash) ;
			bDigest = m_ccaSafeTest.hashDataBufferDigest() ;
			
			System.out.println(sAlgo + ": " + ccvConverter.bytesToHexString(bDigest)) ;
			
		}
        
        /*
        for(int nCnt = 0 ; nCnt < 2 ; nCnt ++)
        {
            if(nCnt == 0)
            {
                sAlgo = "MD5" ;
            }
            else
            {
                sAlgo = "SHA-1" ;
            }
            
            String sHex = m_ccaSafeTest.hashBufferHex(sAlgo, bToHash) ;
            
            System.out.println(sAlgo + " hashBufferHex: " + sHex) ;           
        }        
        */
	}

}
