// 19/11/99 00:10 GR - Release
// 20/11/99 01:10 GR - Add comments
// 16/09/00 17:50 NDP - new package name

package com.safeapi.test;

/**
 * This class is to be extended for each TestCryptDir class.
 * <BR>
 * It provides usefull services for such classes, especially timers. 
 */

public class TestTimer
{
	// attributes
	
	long	m_lStart ;
	long	m_lEnd ;
	String	m_sOutMsg ;
	String	m_sUnit ;
	
	// constructor

	
	/**
	 * simple constructor
	 */
	
	public TestTimer()
	{
		m_sOutMsg = "Time elapsed : " ;
		m_sUnit = "s" ; 
		m_lStart = 0 ;
		m_lEnd = 0 ;
	}
	
	// methods
	
	/**
	 * indicates time period between start and stop
	 * 
	 * @return	The expression of the last operation duration
	 */
	
	protected String getTimeString()
	{
		return "(" + m_sOutMsg + getDuration()+ m_sUnit + ")" ;
	}
	
	/**
	 * return a String representation of this object 
	 * 
	 * @return	The duration of the last operation
	 */
	
	public String toString()
	{
		return getTimeString() ;
	}
	
	/**
	 * launch the timer
	 */
	
	protected void beginCount()
	{
		m_lStart = System.currentTimeMillis();
		m_lEnd = m_lStart ;
	}
	
	/**
	 * stop the timer
	 */
	
	protected void stopCount()
	{
		m_lEnd = System.currentTimeMillis();
	}
	
	
	/**
	 * compute and return the last operation duration in seconds.
	 * <BR>
	 * i.e. = time at stopCount call - time at beginCount call
	 * 
	 * @return		the last operation duration in seconds
	 */
	
	public float getDuration()
	{
		return ((float) (m_lEnd - m_lStart) / 1000) ;
	}
	
	/**
	 * indicate the operation start with provided message and start timer
	 * 
	 * @param	sMsg	The message to display to indicate the start of operation
	 */
	
	protected void beginOp(String sMsg)
	{
		System.out.println(sMsg) ;
		beginCount() ;
	}
	
	/**
	 * stop timer and indicate the operation stop with provided message
	 * 
	 * @param	sMsg	The message to display to indicate the end of operation
	 */
	
	protected void stopOp(String sMsg)
	{
		stopCount() ;
		System.out.println(sMsg + " " + getTimeString()) ;
	}
}
